Index: c/src/lib/libbsp/m68k/mvme136/ChangeLog
===================================================================
--- c/src/lib/libbsp/m68k/mvme136/ChangeLog	(revision 3d4967b3c8a6ac5e8bb52121335cf56f2917bb28)
+++ c/src/lib/libbsp/m68k/mvme136/ChangeLog	(revision 802359ead8299889d739222af160ce0a466e324b)
@@ -1,2 +1,12 @@
+2004-01-28	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Merge-in clock/Makefile.am, console/Makefile.am,
+	shmsupp/Makefile.am, startup/Makefile.am, timer/Makefile.am,
+	wrapup/Makefile.am.
+	* clock/Makefile.am, console/Makefile.am, shmsupp/Makefile.am
+	startup/Makefile.am, timer/Makefile.am, wrapup/Makefile.am:
+	Remove.
+	* configure.ac: Reflect changes above.
+
 2004-01-21	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: c/src/lib/libbsp/m68k/mvme136/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme136/Makefile.am	(revision 3d4967b3c8a6ac5e8bb52121335cf56f2917bb28)
+++ c/src/lib/libbsp/m68k/mvme136/Makefile.am	(revision 802359ead8299889d739222af160ce0a466e324b)
@@ -8,19 +8,116 @@
 include $(top_srcdir)/../../bsp.am
 
-# wrapup is the one that actually builds and installs the library
-# from the individual .rel files built in other directories
-SUBDIRS = . startup clock console shmsupp timer wrapup
+EXTRA_PROGRAMS =
+CLEANFILES =
+noinst_DATA =
 
 include_HEADERS += include/coverhd.h
 
-m68k_sharedS_FILES = $(top_srcdir)/../../m68k/shared/start.S
-$(ARCH)/%$(LIB_VARIANT).$(OBJEXT): $(top_srcdir)/../../m68k/shared/start.S $(ARCH)/$(dirstamp)
+EXTRA_DIST = ../../m68k/shared/start.S
+start$(LIB_VARIANT).$(OBJEXT): ../../m68k/shared/start.S
 	${CCASCOMPILE} -DASM -o $@ -c $<
 
-project_lib_DATA = $(ARCH)/start$(LIB_VARIANT).$(OBJEXT)
+project_lib_DATA = start$(LIB_VARIANT).$(OBJEXT)
+
+dist_project_lib_DATA += startup/linkcmds
+
+EXTRA_PROGRAMS += startup.rel
+CLEANFILES += startup.rel
+startup_rel_SOURCES = startup/bspclean.c ../../shared/bsplibc.c \
+    ../../shared/bsppost.c startup/bspstart.c ../../shared/bootcard.c \
+    ../shared/m68kpretaskinghook.c ../../shared/main.c ../../shared/sbrk.c \
+    ../shared/setvec.c ../../shared/gnatinstallhandler.c
+startup_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_OPTIMIZE_V)
+startup_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
+
+EXTRA_PROGRAMS += startup_g.rel
+CLEANFILES += startup_g.rel
+startup_g_rel_SOURCES = $(startup_rel_SOURCES)
+startup_g_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_DEBUG_V)
+startup_g_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
+
+noinst_DATA += startup$(LIB_VARIANT).rel
+
+EXTRA_PROGRAMS += clock.rel
+CLEANFILES += clock.rel
+clock_rel_SOURCES = clock/ckinit.c
+clock_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_OPTIMIZE_V)
+clock_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
+
+EXTRA_PROGRAMS += clock_g.rel
+CLEANFILES += clock_g.rel
+clock_g_rel_SOURCES = $(clock_rel_SOURCES)
+clock_g_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_DEBUG_V)
+clock_g_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
+
+noinst_DATA += clock$(LIB_VARIANT).rel
+
+EXTRA_PROGRAMS += console.rel
+CLEANFILES += console.rel
+console_rel_SOURCES = console/console.c
+console_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_OPTIMIZE_V)
+console_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
+
+EXTRA_PROGRAMS += console_g.rel
+CLEANFILES += console_g.rel
+console_g_rel_SOURCES = $(console_rel_SOURCES)
+console_g_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_DEBUG_V)
+console_g_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
+
+noinst_DATA += console$(LIB_VARIANT).rel
+
+EXTRA_PROGRAMS += timer.rel
+CLEANFILES += timer.rel
+timer_rel_SOURCES = timer/timer.c timer/timerisr.S
+timer_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_OPTIMIZE_V)
+timer_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
+
+EXTRA_PROGRAMS += timer_g.rel
+CLEANFILES += timer_g.rel
+timer_g_rel_SOURCES = $(timer_rel_SOURCES)
+timer_g_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_DEBUG_V)
+timer_g_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
+
+noinst_DATA += timer$(LIB_VARIANT).rel
+
+if HAS_MP
+EXTRA_PROGRAMS += shmsupp.rel
+CLEANFILES += shmsupp.rel
+shmsupp_rel_SOURCES = shmsupp/addrconv.c shmsupp/getcfg.c shmsupp/lock.c \
+    shmsupp/mpisr.c
+shmsupp_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_OPTIMIZE_V)
+shmsupp_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
+
+EXTRA_PROGRAMS += shmsupp_g.rel
+CLEANFILES += shmsupp_g.rel
+shmsupp_g_rel_SOURCES = $(shmsupp_rel_SOURCES)
+shmsupp_g_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_DEBUG_V)
+shmsupp_g_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
+
+noinst_DATA += shmsupp$(LIB_VARIANT).rel
+endif
+
+EXTRA_LIBRARIES = libbsp.a
+CLEANFILES += libbsp.a
+libbsp_a_SOURCES =
+libbsp_a_LIBADD = startup$(LIB_VARIANT).rel clock$(LIB_VARIANT).rel \
+    console$(LIB_VARIANT).rel timer$(LIB_VARIANT).rel
+if HAS_MP
+libbsp_a_LIBADD += shmsupp$(LIB_VARIANT).rel
+endif
+libbsp_a_LIBADD += \
+    ../../../libcpu/@RTEMS_CPU@/shared/cache$(LIB_VARIANT).rel \
+    ../../../libcpu/@RTEMS_CPU@/shared/misc$(LIB_VARIANT).rel
+
+EXTRA_LIBRARIES += libbsp_g.a
+CLEANFILES += libbsp_g.a
+libbsp_g_a_SOURCES = $(libbsp_a_SOURCES)
+libbsp_g_a_LIBADD = $(libbsp_a_LIBADD)
+
+noinst_DATA += libbsp$(LIB_VARIANT).a
 
 all-local: $(PREINSTALL_FILES) $(TMPINSTALL_FILES)
 
-EXTRA_DIST = times
+EXTRA_DIST += times
 
 PREINSTALL_DIRS =
@@ -31,12 +128,15 @@
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/coverhd.h
 
-$(PROJECT_LIB)/start$(LIB_VARIANT).$(OBJEXT): $(ARCH)/start$(LIB_VARIANT).$(OBJEXT) $(PROJECT_LIB)/$(dirstamp)
+$(PROJECT_LIB)/start$(LIB_VARIANT).$(OBJEXT): start$(LIB_VARIANT).$(OBJEXT) $(PROJECT_LIB)/$(dirstamp)
 	$(INSTALL_DATA) $< $(PROJECT_LIB)/start$(LIB_VARIANT).$(OBJEXT)
 TMPINSTALL_FILES += $(PROJECT_LIB)/start$(LIB_VARIANT).$(OBJEXT)
 
-CLEANFILES = $(PREINSTALL_FILES)
+$(PROJECT_LIB)/linkcmds: startup/linkcmds $(PROJECT_LIB)/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_LIB)/linkcmds
+TMPINSTALL_FILES += $(PROJECT_LIB)/linkcmds
+
+CLEANFILES += $(PREINSTALL_FILES)
 DISTCLEANFILES = $(PREINSTALL_DIRS)
 CLEANFILES += $(TMPINSTALL_FILES)
 
-include $(top_srcdir)/../../../../automake/subdirs.am
 include $(top_srcdir)/../../../../automake/local.am
Index: c/src/lib/libbsp/m68k/mvme136/clock/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme136/clock/Makefile.am	(revision 3d4967b3c8a6ac5e8bb52121335cf56f2917bb28)
+++ 	(revision )
@@ -1,30 +1,0 @@
-##
-## $Id$
-##
-
-PGM = $(ARCH)/clock.rel
-
-C_FILES = ckinit.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
-
-OBJS = $(C_O_FILES)
-
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/lib.am
-
-#
-# (OPTIONAL) Add local stuff here using +=
-#
-
-$(PGM): $(OBJS)
-	$(make-rel)
-
-# the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
-
-all-local: $(OBJS) $(PGM)
-
-.PRECIOUS: $(PGM)
-
-EXTRA_DIST = ckinit.c
-
-include $(top_srcdir)/../../../../automake/local.am
Index: c/src/lib/libbsp/m68k/mvme136/configure.ac
===================================================================
--- c/src/lib/libbsp/m68k/mvme136/configure.ac	(revision 3d4967b3c8a6ac5e8bb52121335cf56f2917bb28)
+++ c/src/lib/libbsp/m68k/mvme136/configure.ac	(revision 802359ead8299889d739222af160ce0a466e324b)
@@ -14,4 +14,5 @@
 RTEMS_PROG_CC_FOR_TARGET([-ansi -fasm])
 RTEMS_CANONICALIZE_TOOLS
+RTEMS_PROG_CCAS
 
 RTEMS_CHECK_MULTIPROCESSING(RTEMS_BSP)
@@ -20,10 +21,4 @@
 
 # Explicitly list all Makefiles here
-AC_CONFIG_FILES([Makefile
-clock/Makefile
-console/Makefile
-shmsupp/Makefile
-startup/Makefile
-timer/Makefile
-wrapup/Makefile])
+AC_CONFIG_FILES([Makefile])
 AC_OUTPUT
Index: c/src/lib/libbsp/m68k/mvme136/console/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme136/console/Makefile.am	(revision 3d4967b3c8a6ac5e8bb52121335cf56f2917bb28)
+++ 	(revision )
@@ -1,30 +1,0 @@
-##
-## $Id$
-##
-
-PGM = $(ARCH)/console.rel
-
-C_FILES = console.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
-
-OBJS = $(C_O_FILES)
-
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/lib.am
-
-#
-# (OPTIONAL) Add local stuff here using +=
-#
-
-$(PGM): $(OBJS)
-	$(make-rel)
-
-# the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
-
-all-local: $(OBJS) $(PGM)
-
-.PRECIOUS: $(PGM)
-
-EXTRA_DIST = console.c
-
-include $(top_srcdir)/../../../../automake/local.am
Index: c/src/lib/libbsp/m68k/mvme136/shmsupp/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme136/shmsupp/Makefile.am	(revision 3d4967b3c8a6ac5e8bb52121335cf56f2917bb28)
+++ 	(revision )
@@ -1,32 +1,0 @@
-##
-## $Id$
-##
-
-PGM = $(ARCH)/shmsupp.rel
-
-C_FILES = addrconv.c getcfg.c lock.c mpisr.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
-
-OBJS = $(C_O_FILES)
-
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/lib.am
-
-#
-# (OPTIONAL) Add local stuff here using +=
-#
-
-$(PGM): $(OBJS)
-	$(make-rel)
-
-# the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
-
-if HAS_MP
-all-local: $(OBJS) $(PGM)
-endif
-
-.PRECIOUS: $(PGM)
-
-EXTRA_DIST = addrconv.c getcfg.c lock.c mpisr.c
-
-include $(top_srcdir)/../../../../automake/local.am
Index: c/src/lib/libbsp/m68k/mvme136/startup/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme136/startup/Makefile.am	(revision 3d4967b3c8a6ac5e8bb52121335cf56f2917bb28)
+++ 	(revision )
@@ -1,46 +1,0 @@
-##
-## $Id$
-##
-
-VPATH = @srcdir@:@srcdir@/../../shared:@srcdir@/../../../shared
-
-PGM = $(ARCH)/startup.rel
-
-C_FILES = bspclean.c bsplibc.c bsppost.c bspstart.c bootcard.c \
-    m68kpretaskinghook.c main.c sbrk.c setvec.c gnatinstallhandler.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
-
-OBJS = $(C_O_FILES)
-
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/lib.am
-
-#
-# (OPTIONAL) Add local stuff here using +=
-#
-
-$(PGM): $(OBJS)
-	$(make-rel)
-
-project_lib_DATA = linkcmds
-
-# the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
-
-all-local: $(PGM) $(TMPINSTALL_FILES)
-
-EXTRA_DIST = bspclean.c bspstart.c linkcmds
-
-TMPINSTALL_FILES =
-
-$(PROJECT_LIB)/$(dirstamp):
-	@$(mkdir_p) $(PROJECT_LIB)
-	@: > $(PROJECT_LIB)/$(dirstamp)
-TMPINSTALL_FILES += $(PROJECT_LIB)/$(dirstamp)
-
-$(PROJECT_LIB)/linkcmds: linkcmds $(PROJECT_LIB)/$(dirstamp)
-	$(INSTALL_DATA) $< $(PROJECT_LIB)/linkcmds
-TMPINSTALL_FILES += $(PROJECT_LIB)/linkcmds
-
-CLEANFILES = $(TMPINSTALL_FILES)
-
-include $(top_srcdir)/../../../../automake/local.am
Index: c/src/lib/libbsp/m68k/mvme136/timer/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme136/timer/Makefile.am	(revision 3d4967b3c8a6ac5e8bb52121335cf56f2917bb28)
+++ 	(revision )
@@ -1,33 +1,0 @@
-##
-## $Id$
-##
-
-PGM = $(ARCH)/timer.rel
-
-C_FILES = timer.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
-
-S_FILES = timerisr.S
-S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.$(OBJEXT))
-
-OBJS = $(C_O_FILES) $(S_O_FILES)
-
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/lib.am
-
-#
-# (OPTIONAL) Add local stuff here using +=
-#
-
-$(PGM): $(OBJS)
-	$(make-rel)
-
-# the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
-
-all-local: $(OBJS) $(PGM)
-
-.PRECIOUS: $(PGM)
-
-EXTRA_DIST = timer.c timerisr.S
-
-include $(top_srcdir)/../../../../automake/local.am
Index: c/src/lib/libbsp/m68k/mvme136/wrapup/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme136/wrapup/Makefile.am	(revision 3d4967b3c8a6ac5e8bb52121335cf56f2917bb28)
+++ 	(revision )
@@ -1,23 +1,0 @@
-##
-## $Id$
-##
-
-include $(top_srcdir)/../../../../automake/compile.am
-include $(top_srcdir)/../../../../automake/lib.am
-
-if HAS_MP
-BSP_MP_O_PIECES = shmsupp
-endif
-BSP_PIECES = startup clock console timer $(BSP_MP_O_PIECES)
-
-# bummer; have to use $foreach since % pattern subst rules only replace 1x
-OBJS = $(foreach piece, $(BSP_PIECES), ../$(piece)/$(ARCH)/*.$(OBJEXT)) \
-    ../../../../libcpu/@RTEMS_CPU@/shared/cache$(LIB_VARIANT).rel \
-    ../../../../libcpu/@RTEMS_CPU@/shared/misc$(LIB_VARIANT).rel
-
-$(ARCH)/libbsp.a: $(OBJS)
-	$(make-library)
-
-noinst_DATA = $(ARCH)/libbsp.a
-
-include $(top_srcdir)/../../../../automake/local.am