Index: cpukit/Makefile.am
===================================================================
--- cpukit/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-# $Id$
-#
+##
+## $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
Index: cpukit/libcsupport/Makefile.am
===================================================================
--- cpukit/libcsupport/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/libcsupport/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-#  $Id$
-#
+##
+##  $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
Index: cpukit/libmisc/Makefile.am
===================================================================
--- cpukit/libmisc/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/libmisc/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-#  $Id$
-#
+##
+##  $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
Index: cpukit/libnetworking/Makefile.am
===================================================================
--- cpukit/libnetworking/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/libnetworking/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-# $Id$
-#
+##
+## $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
Index: cpukit/librpc/include/rpc/Makefile.am
===================================================================
--- cpukit/librpc/include/rpc/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/librpc/include/rpc/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-# $Id$
-#
+##
+## $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
Index: cpukit/posix/Makefile.am
===================================================================
--- cpukit/posix/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/posix/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-# $Id$
-#
+##
+## $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
Index: cpukit/posix/include/Makefile.am
===================================================================
--- cpukit/posix/include/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/posix/include/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,9 +1,9 @@
-#
-# $Id$
-#
+##
+## $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
 
-# RTEMS unistd.h needs to be checked against newlib's and removed
+## RTEMS unistd.h needs to be checked against newlib's and removed
 #noinst_HEADERS= devctl.h intr.h
 H_PIECES = pthread.h sched.h aio.h mqueue.h semaphore.h
Index: cpukit/posix/inline/Makefile.am
===================================================================
--- cpukit/posix/inline/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/posix/inline/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-# $Id$
-#
+##
+## $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
Index: cpukit/posix/macros/Makefile.am
===================================================================
--- cpukit/posix/macros/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/posix/macros/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-# $Id$
-#
+##
+## $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
Index: cpukit/rtems/Makefile.am
===================================================================
--- cpukit/rtems/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/rtems/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-# $Id$
-#
+##
+## $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
Index: cpukit/rtems/include/Makefile.am
===================================================================
--- cpukit/rtems/include/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/rtems/include/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-#  $Id$
-#
+##
+##  $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
Index: cpukit/rtems/inline/Makefile.am
===================================================================
--- cpukit/rtems/inline/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/rtems/inline/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-# $Id$
-#
+##
+## $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
Index: cpukit/rtems/macros/Makefile.am
===================================================================
--- cpukit/rtems/macros/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/rtems/macros/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-# $Id$
-#
+##
+## $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
Index: cpukit/sapi/Makefile.am
===================================================================
--- cpukit/sapi/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/sapi/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-# $Id$
-#
+##
+## $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
Index: cpukit/sapi/include/Makefile.am
===================================================================
--- cpukit/sapi/include/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/sapi/include/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-# $Id$
-#
+##
+## $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
Index: cpukit/sapi/inline/Makefile.am
===================================================================
--- cpukit/sapi/inline/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/sapi/inline/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-# $Id$
-#
+##
+## $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
Index: cpukit/sapi/macros/Makefile.am
===================================================================
--- cpukit/sapi/macros/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/sapi/macros/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-# $Id$
-#
+##
+## $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
Index: cpukit/score/Makefile.am
===================================================================
--- cpukit/score/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/score/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-# $Id$
-#
+##
+## $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
Index: cpukit/score/include/Makefile.am
===================================================================
--- cpukit/score/include/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/score/include/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-# $Id$
-#
+##
+## $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
Index: cpukit/score/inline/Makefile.am
===================================================================
--- cpukit/score/inline/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/score/inline/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-# $Id$
-#
+##
+## $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
Index: cpukit/score/macros/Makefile.am
===================================================================
--- cpukit/score/macros/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/score/macros/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-# $Id$
-#
+##
+## $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4
Index: cpukit/wrapup/Makefile.am
===================================================================
--- cpukit/wrapup/Makefile.am	(revision 0efa9f01f80d98aabc54a87748d60cd19be2416c)
+++ cpukit/wrapup/Makefile.am	(revision 811804fec86c4c6333c9ae56bedf72cbd7639c9d)
@@ -1,5 +1,5 @@
-#
-# $Id$
-#
+##
+## $Id$
+##
 
 AUTOMAKE_OPTIONS = foreign 1.4