Index: make/ChangeLog
===================================================================
--- make/ChangeLog	(revision 581c31171b5cbf9cb6c9c5a392bfe4dc200affde)
+++ make/ChangeLog	(revision 888622c431f5444b54d0fc4c85d1f194414bbc1b)
@@ -1,2 +1,11 @@
+2003-06-06	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	PR 321:
+	* leaf.cfg: Remove support for profile-variant.
+	* main.cfg: Ditto.
+	* compilers/gcc-no_bsp.cfg: Ditto.
+	* compilers/gcc-portsw.cfg: Ditto.
+	* compilers/gcc-target-default.cfg: Ditto.
+
 2003-05-27	Ralf Corsepius	<corsepiu@faw.uni-ulm.de>
 
Index: make/compilers/gcc-no_bsp.cfg
===================================================================
--- make/compilers/gcc-no_bsp.cfg	(revision 581c31171b5cbf9cb6c9c5a392bfe4dc200affde)
+++ make/compilers/gcc-no_bsp.cfg	(revision 888622c431f5444b54d0fc4c85d1f194414bbc1b)
@@ -10,5 +10,5 @@
 GNU_TOOLS_PREFIX=
 
-# Additional target names (other than debug, profile)
+# Additional target names (other than debug)
 TARGET_VARIANTS +=
 
@@ -55,9 +55,9 @@
 
 #
-# CFLAGS_OPTIMIZE_V, CFLAGS_DEBUG_V, CFLAGS_PROFILE_V are the values we
+# CFLAGS_OPTIMIZE_V, CFLAGS_DEBUG_V are the values we
 # would want the corresponding macros to be set to.
 #
-# CFLAGS_OPTIMIZE, CFLAGS_DEBUG, CFLAGS_PROFILE are set in the leaf
-# Makefiles by the 'debug:' and 'profile:' targets to their _V values.
+# CFLAGS_OPTIMIZE, CFLAGS_DEBUG are set in the leaf
+# Makefiles by the 'debug:' targets to their _V values.
 #
 
@@ -79,7 +79,4 @@
 CFLAGS_DEBUG_V=-g -Wno-unused
 
-# profile flag; use gprof(1)
-CFLAGS_PROFILE_V=-pg
-
 # default is to optimize
 CFLAGS_OPTIMIZE=$(CFLAGS_OPTIMIZE_V)
@@ -89,5 +86,5 @@
 # ASFLAGS_DYNAMIC_V=
 
-CFLAGS=$(CFLAGS_DEFAULT) $(CFLAGS_OPTIMIZE) $(CFLAGS_DEBUG) $(CFLAGS_PROFILE) \
+CFLAGS=$(CFLAGS_DEFAULT) $(CFLAGS_OPTIMIZE) $(CFLAGS_DEBUG) \
        -I $(PROJECT_INCLUDE)
 
@@ -116,8 +113,7 @@
 
 # ld flags for profiling, debugging
-LDFLAGS_PROFILE_V =
 LDFLAGS_DEBUG_V =
 
-LDFLAGS=$(LDFLAGS_PROFILE) $(LDFLAGS_DEBUG) $(LD_PATHS:%=-L %)
+LDFLAGS=$(LDFLAGS_DEBUG) $(LD_PATHS:%=-L %)
 
 #
@@ -223,5 +219,5 @@
 #       Replace foo.o with $(ARCH)/foo.o
 #       Replace $(ARCH) value with string $(ARCH)
-#           so that it will for debug and profile cases
+#           so that it will for debug cases
 	$(COMPILE.c) -M   $^    |  \
 	$(SED) -e 's?^\(.*\)\.o[ ]*:?$$(ARCH)/\1.o:?' \
Index: make/compilers/gcc-portsw.cfg
===================================================================
--- make/compilers/gcc-portsw.cfg	(revision 581c31171b5cbf9cb6c9c5a392bfe4dc200affde)
+++ make/compilers/gcc-portsw.cfg	(revision 888622c431f5444b54d0fc4c85d1f194414bbc1b)
@@ -11,5 +11,5 @@
 GNU_TOOLS_PREFIX=
 
-# Additional target names (other than debug, profile)
+# Additional target names (other than debug)
 TARGET_VARIANTS +=
 
@@ -41,9 +41,9 @@
 
 #
-# CFLAGS_OPTIMIZE_V, CFLAGS_DEBUG_V, CFLAGS_PROFILE_V are the values we
+# CFLAGS_OPTIMIZE_V, CFLAGS_DEBUG_V are the values we
 # would want the corresponding macros to be set to.
 #
-# CFLAGS_OPTIMIZE, CFLAGS_DEBUG, CFLAGS_PROFILE are set in the leaf
-# Makefiles by the 'debug:' and 'profile:' targets to their _V values.
+# CFLAGS_OPTIMIZE, CFLAGS_DEBUG are set in the leaf
+# Makefiles by the 'debug:' targets to their _V values.
 #
 
@@ -61,7 +61,4 @@
 CFLAGS_DEBUG_V=-g -O0 -DRTEMS_DEBUG -DSTACK_CHECKER_ON
 
-# profile flag; use gprof(1)
-CFLAGS_PROFILE_V=
-
 # default is to optimize
 CFLAGS_OPTIMIZE=$(CFLAGS_OPTIMIZE_V)
@@ -71,5 +68,5 @@
 #ASFLAGS_DYNAMIC_V=
 
-CFLAGS=$(CFLAGS_DEFAULT) $(CFLAGS_OPTIMIZE) $(CFLAGS_DEBUG) $(CFLAGS_PROFILE)
+CFLAGS=$(CFLAGS_DEFAULT) $(CFLAGS_OPTIMIZE) $(CFLAGS_DEBUG)
 
 # List of library paths without -L
@@ -97,8 +94,7 @@
 
 # ld flags for profiling, debugging
-LDFLAGS_PROFILE_V =
 LDFLAGS_DEBUG_V =
 
-LDFLAGS=$(LDFLAGS_PROFILE) $(LDFLAGS_DEBUG) $(LD_PATHS:%=-L %)
+LDFLAGS=$(LDFLAGS_DEBUG) $(LD_PATHS:%=-L %)
 
 #
@@ -211,5 +207,5 @@
 #       Replace foo.o with $(ARCH)/foo.o
 #       Replace $(ARCH) value with string $(ARCH)
-#           so that it will for debug and profile cases
+#           so that it will for debug cases
 	$(COMPILE.c) -Hmake $^ | \
 	    $(SED) -e 's?^\(.*\)\.o[ ]*:?$$(ARCH)/\1.o:?' \
Index: make/compilers/gcc-target-default.cfg
===================================================================
--- make/compilers/gcc-target-default.cfg	(revision 581c31171b5cbf9cb6c9c5a392bfe4dc200affde)
+++ make/compilers/gcc-target-default.cfg	(revision 888622c431f5444b54d0fc4c85d1f194414bbc1b)
@@ -6,9 +6,9 @@
 
 ##
-# CFLAGS_OPTIMIZE_V, CFLAGS_DEBUG_V, CFLAGS_PROFILE_V are the values we
+# CFLAGS_OPTIMIZE_V, CFLAGS_DEBUG_V are the values we
 # would want the corresponding macros to be set to.
 #
-# CFLAGS_OPTIMIZE, CFLAGS_DEBUG, CFLAGS_PROFILE are set in the leaf
-# Makefiles by the 'debug:' and 'profile:' targets to their _V values.
+# CFLAGS_OPTIMIZE, CFLAGS_DEBUG are set in the leaf
+# Makefiles by the 'debug:' targets to their _V values.
 #
 
@@ -56,8 +56,4 @@
 CXXFLAGS_OPTIMIZE_V+=-g
 
-# profile flag; use gprof(1)
-CFLAGS_PROFILE_V+=-pg
-CXXFLAGS_PROFILE_V+=-pg
-
 ifndef AUTOMAKE
 CFLAGS_$(VARIANT)  =$(CFLAGS_$(VARIANT)_V)
@@ -66,6 +62,6 @@
 
 ifndef AUTOMAKE
-CFLAGS   += $(CFLAGS_OPTIMIZE) $(CFLAGS_DEBUG) $(CFLAGS_PROFILE)
-CXXFLAGS += $(CXXFLAGS_OPTIMIZE) $(CXXFLAGS_DEBUG) $(CXXFLAGS_PROFILE)
+CFLAGS   += $(CFLAGS_OPTIMIZE) $(CFLAGS_DEBUG)
+CXXFLAGS += $(CXXFLAGS_OPTIMIZE) $(CXXFLAGS_DEBUG)
 endif
 
@@ -94,8 +90,7 @@
 
 # ld flags for profiling, debugging
-LDFLAGS_PROFILE_V =
 LDFLAGS_DEBUG_V = -qrtems_debug
 
-LDFLAGS=$(LDFLAGS_PROFILE) $(LDFLAGS_DEBUG) $(LD_PATHS:%=-L %)
+LDFLAGS=$(LDFLAGS_DEBUG) $(LD_PATHS:%=-L %)
 
 #
@@ -170,5 +165,5 @@
 #       Replace foo.o with $(ARCH)/foo.o
 #       Replace $(ARCH) value with string $(ARCH)
-#           so that it will for debug and profile cases
+#           so that it will for debug cases
 	$(COMPILE.c) $(AM_CPPFLAGS) $(AM_CFLAGS) -M   $^    |  \
 	$(SED) -e 's?^\(.*\)\.o[ ]*:?$$(ARCH)/\1.o:?' \
Index: make/leaf.cfg
===================================================================
--- make/leaf.cfg	(revision 581c31171b5cbf9cb6c9c5a392bfe4dc200affde)
+++ make/leaf.cfg	(revision 888622c431f5444b54d0fc4c85d1f194414bbc1b)
@@ -37,5 +37,5 @@
 #
 # LIBSUFFIX_VA, will "index" into LIBSUFF-*-v macros and
-#   convert our ${ARCH} back into .a or _g.a or _p.a based on debug or profile.
+#   convert our ${ARCH} back into .a or _g.a or _p.a based on debug.
 #   Useful for installing libraries.
 #
@@ -43,5 +43,4 @@
 LIBSUFFIX_OPTIMIZE_V=
 LIBSUFFIX_DEBUG_V=_g
-LIBSUFFIX_PROFILE_V=_p
 
 LIB_VARIANT=$(LIBSUFFIX_$(VARIANT_V)_V)
@@ -62,11 +61,8 @@
 debug:
 	$(MAKE) -f $(MAKEFILE) MAKEFILE=$(MAKEFILE) VARIANT=DEBUG
-
-profile:
-	$(MAKE) -f $(MAKEFILE) MAKEFILE=$(MAKEFILE) VARIANT=PROFILE
 endif
 
 #
-# VARIANT_VA will convert our ${ARCH} back into "" or "debug" or "profile".
+# VARIANT_VA will convert our ${ARCH} back into "" or "debug".
 #   Handy when one makefile wants to hop over into a peer's tree and
 #   build something "the same" way.
@@ -75,10 +71,9 @@
 VARIANT-OPTIMIZE-v =
 VARIANT-DEBUG-v = debug
-VARIANT-PROFILE-v = profile
 
 VARIANT_VA = $(VARIANT-$(VARIANT_V)-v)
 
 #
-# TARGET_VA will convert $@ (expected to be 'debug' or 'profile' etc.)
+# TARGET_VA will convert $@ (expected to be 'debug' etc.)
 #   into "" or "install" as appropriate.
 #   Used for variant recursion.
@@ -86,5 +81,4 @@
 
 TARGET_debug_V = all
-TARGET_profile_V = all
 
 TARGET_VA = $(TARGET_$@_V)
Index: make/main.cfg
===================================================================
--- make/main.cfg	(revision 581c31171b5cbf9cb6c9c5a392bfe4dc200affde)
+++ make/main.cfg	(revision 888622c431f5444b54d0fc4c85d1f194414bbc1b)
@@ -32,8 +32,6 @@
 VARIANT_OPTIMIZE_V = OPTIMIZE
 VARIANT_DEBUG_V = DEBUG
-VARIANT_PROFILE_V = PROFILE
 VARIANT_optimize_V = OPTIMIZE
 VARIANT_debug_V = DEBUG
-VARIANT_profile_V = PROFILE
 
 VARIANT_V = $(VARIANT_$(VARIANT)_V)
@@ -42,5 +40,4 @@
 ARCH_OPTIMIZE_V = o-optimize
 ARCH_DEBUG_V = o-debug
-ARCH_PROFILE_V = o-profile
 
 ARCH__V = $(ARCH_OPTIMIZE_V)
@@ -59,8 +56,8 @@
 # Target variant names
 #
-TARGET_VARIANTS = optimize debug profile
+TARGET_VARIANTS = optimize debug
 
 #
-# Generate list of object directories: o-optimize, o-debug, o-profile
+# Generate list of object directories: o-optimize, o-debug
 #
 VARIANTS=${TARGET_VARIANTS:%=o-%}