Index: contrib/crossrpms/rtems4.9/arm/gdb-sources.add
===================================================================
--- contrib/crossrpms/rtems4.9/arm/gdb-sources.add	(revision 2870240a155a7278e8044c2ca1062f6c8820f717)
+++ contrib/crossrpms/rtems4.9/arm/gdb-sources.add	(revision 905700d490dac7363372397daa4e1ccda5d41ad1)
@@ -2,4 +2,4 @@
 %{?_without_sources:NoSource:	0}
 %if "%{gdb_version}" == "6.8"
-Patch0:		gdb-6.8-rtems4.9-20080428.diff
+Patch0:		gdb-6.8-rtems4.9-20080429.diff
 %endif
Index: contrib/crossrpms/rtems4.9/avr/gdb-sources.add
===================================================================
--- contrib/crossrpms/rtems4.9/avr/gdb-sources.add	(revision 2870240a155a7278e8044c2ca1062f6c8820f717)
+++ contrib/crossrpms/rtems4.9/avr/gdb-sources.add	(revision 905700d490dac7363372397daa4e1ccda5d41ad1)
@@ -2,4 +2,4 @@
 %{?_without_sources:NoSource:	0}
 %if "%{gdb_version}" == "6.8"
-Patch0:		gdb-6.8-rtems4.9-20080428.diff
+Patch0:		gdb-6.8-rtems4.9-20080429.diff
 %endif
Index: contrib/crossrpms/rtems4.9/h8300/gdb-sources.add
===================================================================
--- contrib/crossrpms/rtems4.9/h8300/gdb-sources.add	(revision 2870240a155a7278e8044c2ca1062f6c8820f717)
+++ contrib/crossrpms/rtems4.9/h8300/gdb-sources.add	(revision 905700d490dac7363372397daa4e1ccda5d41ad1)
@@ -2,4 +2,4 @@
 %{?_without_sources:NoSource:	0}
 %if "%{gdb_version}" == "6.8"
-Patch0:		gdb-6.8-rtems4.9-20080428.diff
+Patch0:		gdb-6.8-rtems4.9-20080429.diff
 %endif
Index: contrib/crossrpms/rtems4.9/i386/gdb-sources.add
===================================================================
--- contrib/crossrpms/rtems4.9/i386/gdb-sources.add	(revision 2870240a155a7278e8044c2ca1062f6c8820f717)
+++ contrib/crossrpms/rtems4.9/i386/gdb-sources.add	(revision 905700d490dac7363372397daa4e1ccda5d41ad1)
@@ -2,4 +2,4 @@
 %{?_without_sources:NoSource:	0}
 %if "%{gdb_version}" == "6.8"
-Patch0:		gdb-6.8-rtems4.9-20080428.diff
+Patch0:		gdb-6.8-rtems4.9-20080429.diff
 %endif
Index: contrib/crossrpms/rtems4.9/m68k/gdb-sources.add
===================================================================
--- contrib/crossrpms/rtems4.9/m68k/gdb-sources.add	(revision 2870240a155a7278e8044c2ca1062f6c8820f717)
+++ contrib/crossrpms/rtems4.9/m68k/gdb-sources.add	(revision 905700d490dac7363372397daa4e1ccda5d41ad1)
@@ -2,4 +2,4 @@
 %{?_without_sources:NoSource:	0}
 %if "%{gdb_version}" == "6.8"
-Patch0:		gdb-6.8-rtems4.9-20080428.diff
+Patch0:		gdb-6.8-rtems4.9-20080429.diff
 %endif
Index: contrib/crossrpms/rtems4.9/mips/gdb-sources.add
===================================================================
--- contrib/crossrpms/rtems4.9/mips/gdb-sources.add	(revision 2870240a155a7278e8044c2ca1062f6c8820f717)
+++ contrib/crossrpms/rtems4.9/mips/gdb-sources.add	(revision 905700d490dac7363372397daa4e1ccda5d41ad1)
@@ -2,4 +2,4 @@
 %{?_without_sources:NoSource:	0}
 %if "%{gdb_version}" == "6.8"
-Patch0:		gdb-6.8-rtems4.9-20080428.diff
+Patch0:		gdb-6.8-rtems4.9-20080429.diff
 %endif
Index: contrib/crossrpms/rtems4.9/mipstx39/gdb-sources.add
===================================================================
--- contrib/crossrpms/rtems4.9/mipstx39/gdb-sources.add	(revision 2870240a155a7278e8044c2ca1062f6c8820f717)
+++ contrib/crossrpms/rtems4.9/mipstx39/gdb-sources.add	(revision 905700d490dac7363372397daa4e1ccda5d41ad1)
@@ -2,4 +2,4 @@
 %{?_without_sources:NoSource:	0}
 %if "%{gdb_version}" == "6.8"
-Patch0:		gdb-6.8-rtems4.9-20080428.diff
+Patch0:		gdb-6.8-rtems4.9-20080429.diff
 %endif
Index: contrib/crossrpms/rtems4.9/powerpc/gdb-sources.add
===================================================================
--- contrib/crossrpms/rtems4.9/powerpc/gdb-sources.add	(revision 2870240a155a7278e8044c2ca1062f6c8820f717)
+++ contrib/crossrpms/rtems4.9/powerpc/gdb-sources.add	(revision 905700d490dac7363372397daa4e1ccda5d41ad1)
@@ -2,4 +2,4 @@
 %{?_without_sources:NoSource:	0}
 %if "%{gdb_version}" == "6.8"
-Patch0:		gdb-6.8-rtems4.9-20080428.diff
+Patch0:		gdb-6.8-rtems4.9-20080429.diff
 %endif
Index: contrib/crossrpms/rtems4.9/sh/gdb-sources.add
===================================================================
--- contrib/crossrpms/rtems4.9/sh/gdb-sources.add	(revision 2870240a155a7278e8044c2ca1062f6c8820f717)
+++ contrib/crossrpms/rtems4.9/sh/gdb-sources.add	(revision 905700d490dac7363372397daa4e1ccda5d41ad1)
@@ -2,4 +2,4 @@
 %{?_without_sources:NoSource:	0}
 %if "%{gdb_version}" == "6.8"
-Patch0:		gdb-6.8-rtems4.9-20080428.diff
+Patch0:		gdb-6.8-rtems4.9-20080429.diff
 %endif
Index: contrib/crossrpms/rtems4.9/sparc/gdb-sources.add
===================================================================
--- contrib/crossrpms/rtems4.9/sparc/gdb-sources.add	(revision 2870240a155a7278e8044c2ca1062f6c8820f717)
+++ contrib/crossrpms/rtems4.9/sparc/gdb-sources.add	(revision 905700d490dac7363372397daa4e1ccda5d41ad1)
@@ -2,4 +2,4 @@
 %{?_without_sources:NoSource:	0}
 %if "%{gdb_version}" == "6.8"
-Patch0:		gdb-6.8-rtems4.9-20080428.diff
+Patch0:		gdb-6.8-rtems4.9-20080429.diff
 %endif