Index: c/src/lib/libbsp/m68k/genmcf548x/ChangeLog
===================================================================
--- c/src/lib/libbsp/m68k/genmcf548x/ChangeLog	(revision 53cb8234bb7fbdd53f59ff3f2853b6803f6bec41)
+++ c/src/lib/libbsp/m68k/genmcf548x/ChangeLog	(revision 939439d3a999f65cea84c84e2afd86854b4aaec0)
@@ -1,2 +1,8 @@
+2008-09-16	Joel Sherrill <joel.sherrill@oarcorp.com>
+
+	* Makefile.am, startup/bspstart.c, startup/init548x.c,
+	startup/linkcmds, startup/linkcmds.m5484FireEngine.flash: Use top
+	level shared bsp_get_work_area() implementation.
+
 2008-09-16	Joel Sherrill <joel.sherrill@oarcorp.com>
 
Index: c/src/lib/libbsp/m68k/genmcf548x/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/genmcf548x/Makefile.am	(revision 53cb8234bb7fbdd53f59ff3f2853b6803f6bec41)
+++ c/src/lib/libbsp/m68k/genmcf548x/Makefile.am	(revision 939439d3a999f65cea84c84e2afd86854b4aaec0)
@@ -27,5 +27,5 @@
 
 startup_SOURCES = startup/bspclean.c ../../shared/bsplibc.c  \
-  ../../shared/bsppost.c ../../m68k/shared/m68kbspgetworkarea.c \
+  ../../shared/bsppost.c ../../shared/bspgetworkarea.c \
   ../../shared/bsppretaskinghook.c ../../shared/bsppredriverhook.c \
   startup/init548x.c startup/bspstart.c ../../shared/bootcard.c \
Index: c/src/lib/libbsp/m68k/genmcf548x/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/m68k/genmcf548x/startup/bspstart.c	(revision 53cb8234bb7fbdd53f59ff3f2853b6803f6bec41)
+++ c/src/lib/libbsp/m68k/genmcf548x/startup/bspstart.c	(revision 939439d3a999f65cea84c84e2afd86854b4aaec0)
@@ -62,5 +62,5 @@
 extern char _CodeFlashSize[];
 extern char _TopRamReserved [];
-extern char _WorkspaceBase [];
+extern char WorkAreaBase [];
 
 /*
Index: c/src/lib/libbsp/m68k/genmcf548x/startup/init548x.c
===================================================================
--- c/src/lib/libbsp/m68k/genmcf548x/startup/init548x.c	(revision 53cb8234bb7fbdd53f59ff3f2853b6803f6bec41)
+++ c/src/lib/libbsp/m68k/genmcf548x/startup/init548x.c	(revision 939439d3a999f65cea84c84e2afd86854b4aaec0)
@@ -64,5 +64,5 @@
 extern uint8_t _BootFlashBase[];
 extern uint8_t _CodeFlashBase[];
-extern uint8_t _RamBase[];
+extern uint8_t RamBase[];
 extern uint32_t InterruptVectorTable[];
 extern uint32_t _VectorRam[];
@@ -208,5 +208,5 @@
             );
         MCF548X_SDRAMC_CS0CFG = (0
-            | MCF548X_SDRAMC_CSnCFG_CSBA((uint32_t)(_RamBase))
+            | MCF548X_SDRAMC_CSnCFG_CSBA((uint32_t)(RamBase))
             | MCF548X_SDRAMC_CSnCFG_CSSZ(MCF548X_SDRAMC_CSnCFG_CSSZ_64MBYTE)
             );
Index: c/src/lib/libbsp/m68k/genmcf548x/startup/linkcmds
===================================================================
--- c/src/lib/libbsp/m68k/genmcf548x/startup/linkcmds	(revision 53cb8234bb7fbdd53f59ff3f2853b6803f6bec41)
+++ c/src/lib/libbsp/m68k/genmcf548x/startup/linkcmds	(revision 939439d3a999f65cea84c84e2afd86854b4aaec0)
@@ -76,8 +76,8 @@
 _TopRamReserved = DEFINED(_TopRamReserved) ? _TopRamReserved : 0;
 
-_RamBase        = DEFINED(_SdramBase)      ? _SdramBase : _SdramBase;
-_RamSize        = DEFINED(_SdramSize)      ? _SdramSize : _SdramSize;
-_HeapSize       = DEFINED(_HeapSize)       ? _HeapSize   : 0x0;
-_VBR            = DEFINED(_VBR)            ? _VBR       : _RamBase;
+RamBase        = DEFINED(_SdramBase)      ? _SdramBase : _SdramBase;
+RamSize        = DEFINED(_SdramSize)      ? _SdramSize : _SdramSize;
+HeapSize       = DEFINED(HeapSize)       ? HeapSize   : 0x0;
+_VBR            = DEFINED(_VBR)            ? _VBR       : RamBase;
 
 __MBAR          = DEFINED(__MBAR)          ? __MBAR     : 0x10000000;
@@ -219,5 +219,5 @@
                 . += _InitStackSize;
                 PROVIDE (_EndInitStackSpace = .);
-                PROVIDE (_WorkspaceBase = .);
+                PROVIDE (WorkAreaBase = .);
         } >sdram
   /* Stabs debugging sections.  */
Index: c/src/lib/libbsp/m68k/genmcf548x/startup/linkcmds.m5484FireEngine.flash
===================================================================
--- c/src/lib/libbsp/m68k/genmcf548x/startup/linkcmds.m5484FireEngine.flash	(revision 53cb8234bb7fbdd53f59ff3f2853b6803f6bec41)
+++ c/src/lib/libbsp/m68k/genmcf548x/startup/linkcmds.m5484FireEngine.flash	(revision 939439d3a999f65cea84c84e2afd86854b4aaec0)
@@ -75,8 +75,8 @@
 _TopRamReserved= DEFINED(_TopRamReserved) ? _TopRamReserved : 0;
 
-_RamBase       = DEFINED(_SdramBase)      ? _SdramBase      : _SdramBase;
-_RamSize       = DEFINED(_SdramSize)      ? _SdramSize      : _SdramSize;
-_HeapSize      = DEFINED(_HeapSize)       ? _HeapSize       : 0x0;
-_VBR           = DEFINED(_VBR)            ? _VBR            : _RamBase;
+RamBase       = DEFINED(_SdramBase)      ? _SdramBase      : _SdramBase;
+RamSize       = DEFINED(_SdramSize)      ? _SdramSize      : _SdramSize;
+HeapSize      = DEFINED(HeapSize)       ? HeapSize       : 0x0;
+_VBR           = DEFINED(_VBR)            ? _VBR            : RamBase;
 
 __MBAR         = DEFINED(__MBAR)          ? __MBAR          : 0x10000000;
@@ -218,5 +218,5 @@
                 . += _InitStackSize;
                 PROVIDE (_EndInitStackSpace = .);
-                PROVIDE (_WorkspaceBase = .);
+                PROVIDE (WorkAreaBase = .);
         } >sdram
   /* Stabs debugging sections.  */